searchData={"items":[{"type":"module","title":"Html5ever","doc":"This is an HTML parser written in Rust.\n\nThe project provides a NIF - Native Implemented Function.\nIt works on top of [a parser of the same name](https://github.com/servo/html5ever)\nfrom the Servo project.\n\nBy default this lib will try to use a precompiled NIF\nfrom the GitHub releases page. This way you don't need\nto have the Rust toolchain installed.\nIn case no precompiled file is found and the Mix env is\nproduction then an error is raised.\n\nYou can force the compilation to occur by setting the\nvalue of the `HTML5EVER_BUILD` environment variable to\n\"true\" or \"1\". Alternatively you can also set the application\nenv `:build_from_source` to `true` in order to force the build:\n\n    config :html5ever, Html5ever, build_from_source: true\n\nThis project is possible thanks to [Rustler](https://hexdocs.pm/rustler).","ref":"Html5ever.html"},{"type":"function","title":"Html5ever.flat_parse/1","doc":"Parses an HTML document from a string and returns a map.\n\nThe map contains the document structure.","ref":"Html5ever.html#flat_parse/1"},{"type":"function","title":"Example - Html5ever.flat_parse/1","doc":"iex> Html5ever.flat_parse(\"<!doctype html>   Hello world   \")\n    {:ok,\n     %{\n       nodes: %{\n         0 => %{id: 0, parent: nil, type: :document},\n         1 => %{id: 1, parent: 0, type: :doctype},\n         2 => %{\n           attrs: [],\n           children: [3, 4],\n           id: 2,\n           name: \"html\",\n           parent: 0,\n           type: :element\n         },\n         3 => %{\n           attrs: [],\n           children: [],\n           id: 3,\n           name: \"head\",\n           parent: 2,\n           type: :element\n         },\n         4 => %{\n           attrs: [],\n           children: [5],\n           id: 4,\n           name: \"body\",\n           parent: 2,\n           type: :element\n         },\n         5 => %{\n           attrs: [],\n           children: [6],\n           id: 5,\n           name: \"h1\",\n           parent: 4,\n           type: :element\n         },\n         6 => %{contents: \"Hello world\", id: 6, parent: 5, type: :text}\n       },\n       root: 0\n     }}","ref":"Html5ever.html#flat_parse/1-example"},{"type":"function","title":"Html5ever.flat_parse_with_attributes_as_maps/1","doc":"Same as `flat_parse/1`, but with attributes as maps.\n\nThis is going to remove duplicated attributes, keeping the ones\nthat appear first.","ref":"Html5ever.html#flat_parse_with_attributes_as_maps/1"},{"type":"function","title":"Html5ever.parse/1","doc":"Parses an HTML document from a string.\n\nThis returns a list of tuples representing the HTML tree.","ref":"Html5ever.html#parse/1"},{"type":"function","title":"Example - Html5ever.parse/1","doc":"iex> Html5ever.parse(\"<!doctype html>   Hello world   \")\n    {:ok,\n     [\n       {:doctype, \"html\", \"\", \"\"},\n       {\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Hello world\"]}]}]}\n     ]}","ref":"Html5ever.html#parse/1-example"},{"type":"function","title":"Html5ever.parse_with_attributes_as_maps/1","doc":"Same as `parse/1`, but with attributes as maps.\n\nThis is going to remove duplicated attributes, keeping the ones\nthat appear first.","ref":"Html5ever.html#parse_with_attributes_as_maps/1"},{"type":"function","title":"Example - Html5ever.parse_with_attributes_as_maps/1","doc":"iex> Html5ever.parse_with_attributes_as_maps(\n    ...>   \"<!doctype html>   Hello world   \"\n    ...> )\n    {:ok,\n     [\n       {:doctype, \"html\", \"\", \"\"},\n       {\"html\", %{}, [{\"head\", %{}, []}, {\"body\", %{}, [{\"h1\", %{\"class\" => \"title\"}, [\"Hello world\"]}]}]}\n     ]}","ref":"Html5ever.html#parse_with_attributes_as_maps/1-example"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.16.1] - 2024-05-15","ref":"changelog.html"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix parsing of HTML documents that may start with a comment or an XML doc tag.\n\n## [0.16.0] - 2024-03-25","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix parsing of comments in `parse/1`.\n- Avoid panic when parsing content with the \"template\" tag.","ref":"changelog.html#fixed"},{"type":"extras","title":"Removed - Changelog","doc":"- Drop support for Elixir 1.12\n\n## [0.15.0] - 2023-06-16","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- Add two new functions to parse documents:\n\n  * `parse_with_attributes_as_maps/1`\n  * `flat_parse_with_attributes_as_maps/1`\n\n  And as the names suggest, it returns a document tree with attributes as maps,\n  instead of lists of pairs. These functions are useful to match node attributes,\n  since the order of attributes does not matter must of the times.","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Use dirty CPU scheduler for all functions. For some reason we were using a \n  normal scheduler, but this could cause instability.\n\n  With a dirty scheduler we can parse medium to big files without worry about\n  lengthy work. Please read https://www.erlang.org/doc/man/erl_nif.html#lengthy_work\n  for further information.","ref":"changelog.html#fixed"},{"type":"extras","title":"Removed - Changelog","doc":"- Remove support for Elixir 1.11.\n\n## [0.14.3] - 2023-05-26","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- Add precompilation target for Linux running on RISC-V 64 bits machines.\n  This is useful for projects using Nerves.\n\n  Note that this is going to require `rustler_precompiled` v0.6 or above, since\n  the that version includes RISC-V on Linux as defaults.\n\n- Add support for OTP 26 by updating the `rustler-sys` package.\n\n## [0.14.2] - 2023-05-20","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Add precompilation target for Linux running on ARM64 machines (both musl and gnu ABI).\n  This is useful for projects using Nerves.\n\n  Note that this is going to require `rustler_precompiled` v0.6 or above, since\n  the that version includes ARM64 on Linux as defaults.\n\n## [0.14.1] - 2023-05-20","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Add support for `rustler_precompiled` v0.6.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Update Rustler version in the crate from `v0.26` to `v0.28`.\n  This shouldn't break anything, but would require the installation of rustler `v0.28`\n  if needed in the Elixir side.\n\n- Change the Rust edition to 2021 (it was 2018). This shouldn't change any behaviour.\n\n## [0.14.0] - 2022-11-04","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Require `rustler_precompiled` equal or above `v0.5.2` - thanks [@Benjamin-Philip](https://github.com/Benjamin-Philip).\n- Use `Application.compile_env/3` instead of `Application.get_env/3` in the native module.\n\n## [0.13.1] - 2022-06-24","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix the precompilation build for targets using `cross` by adding a `Cross.toml`\nfile with a setting telling to read the `RUSTLER_NIF_VERSION` env var from the host machine.\n\n## [0.13.0] - 2022-04-28","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Bump requirement for `rustler_precompiled` to `~> v0.4`. This is needed to avoid installing Rustler by default.\n- Bump `html5ever` (Rust crate) to `v0.26.0`.\n\n## [0.12.0] - 2022-03-14","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Start using [`rustler_precompiled`](https://hex.pm/packages/rustler_precompiled) as\ndependency.\n\n## [0.11.0] - 2021-12-15","ref":"changelog.html#changed"},{"type":"extras","title":"Security - Changelog","doc":"- Add checksum verification of precompiled NIF files before extracting\nthem to the correct location. This is to avoid supply chain attacks.\nWith this change we added a new mix task to download all the files\nand generate the checksum before publishing the package. Additionally\nthe user can download only the local NIF file with the checksum.\nSee the `RELEASE_CHECKLIST.md` file for details on how we ensure this\nworks correctly.","ref":"changelog.html#security"},{"type":"extras","title":"Removed - Changelog","doc":"- Remove support for Elixir 1.10 and below. This is to keep a policy of\nsupporting the latest three Elixir versions.","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- Switch from thread pool to being a dirty NIF. This prevents the \nresulting term from having to be sent between processes, and therefore \nprevents an extra copy from having to be performed.\n- In the FlatSink implementation for the NIF, track children in a pool\ninstead of allocating new vectors for every node. This significantly\nreduces allocator pressure while parsing, and improves performance.\n- When converting a parsed FlatSink into its term representation,\nuse a common child node stack instead of allocating a new one for every\nnode. This significantly reduces allocator pressure while creating terms, \nand improves performance.\n- Start using LTO for the NIF compilation. This reduces the build size\nand improves performance.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix the target selection when using `TARGET_*` env vars on macOS.\n\n## [0.10.1] - 2021-11-24","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- It provides a precompiled NIF for ARM 64 bits running on Linux. This\nis needed for Raspberry PI 4.\n\n## [0.10.0] - 2021-11-24","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Add the ability to download precompiled NIFs. We provide compiled\nNIF files in our GitHub releases page (from GitHub Actions) and the\nlib will try to download the correct NIF respecting the OS, NIF version\nand architecture of your build machine. This also works for Nerves\nprojects that compiles to different targets. This way the Rust toolchain\nis not needed for most of people using this project.","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix compilation on macOS.\n\n## [0.9.0] - 2021-10-02","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Add support for OTP 24. This was achieved by updating Rustler to v0.22.\n\n[Unreleased]: https://github.com/rusterlium/html5ever_elixir/compare/v0.16.1...HEAD\n[0.16.1]: https://github.com/rusterlium/html5ever_elixir/compare/v0.16.0...v0.16.1\n[0.16.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.15.0...v0.16.0\n[0.15.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.14.3...v0.15.0\n[0.14.3]: https://github.com/rusterlium/html5ever_elixir/compare/v0.14.2...v0.14.3\n[0.14.2]: https://github.com/rusterlium/html5ever_elixir/compare/v0.14.1...v0.14.2\n[0.14.1]: https://github.com/rusterlium/html5ever_elixir/compare/v0.14.0...v0.14.1\n[0.14.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.13.1...v0.14.0\n[0.13.1]: https://github.com/rusterlium/html5ever_elixir/compare/v0.13.0...v0.13.1\n[0.13.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.12.0...v0.13.0\n[0.12.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.11.0...v0.12.0\n[0.11.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.10.1...v0.11.0\n[0.10.1]: https://github.com/rusterlium/html5ever_elixir/compare/v0.10.0...v0.10.1\n[0.10.0]: https://github.com/rusterlium/html5ever_elixir/compare/v0.9.0...v0.10.0\n[0.9.0]: https://github.com/rusterlium/html5ever_elixir/releases/tag/v0.9.0","ref":"changelog.html#added"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}